package de.comline.spring.service;

import javax.transaction.Transactional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import de.comline.spring.entity.Movie;
import de.comline.spring.repository.MovieRepository;

@Service
public class MovieService {
	@Autowired
	private MovieRepository repository;
	
	@Transactional
	public Movie createMovie(String title) {
		Movie movie = new Movie(title);
		movie = repository.save(movie);
		return movie;
	}
	
	@Transactional
	public String listAllMovies() {
		StringBuilder buf = new StringBuilder(128);
		repository.findAll().forEach(movie -> buf.append(movie.getTitle()).append(","));
		return buf.toString();
	}
}
